(ns org.opencase.reporting.base-reporter
  (:use org.opencase.clojure.emfquery
        org.opencase.clojure.modelapi
        org.opencase.reporting.report)
  (:import [org.opencase.reporting.report BlockContainer Representant Note Diagram]))

(defn representant-report [representant]
  (let [entity   (first (mselect representant :entity))
        title    (first (mselect entity :id))]
      (Representant. title title))) 

(defn block-container-report [container]
  (let [notes (notes container)]
    (if (empty? notes)
      (BlockContainer. nil nil)
      (BlockContainer. nil (map #(Note. nil (:text %)) notes)))))

(defn diagram-report [diagram]
  (let [container (block-container-report diagram)
        representant (representant-report diagram)]
    (Diagram. (:id representant) (:title representant) nil (:notes container))))

